Index: pkipplib/trunk/pkipplib/pkipplib.py
===================================================================
--- pkipplib/trunk/pkipplib/pkipplib.py (revision 39)
+++ pkipplib/trunk/pkipplib/pkipplib.py (revision 40)
@@ -5,9 +5,9 @@
 #
 # (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
-# This program is free software; you can redistribute it and/or modify
+# This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
+# the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
-#
+# 
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -16,6 +16,5 @@
 # 
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # $Id$
Index: pkipplib/trunk/pkipplib/__init__.py
===================================================================
--- pkipplib/trunk/pkipplib/__init__.py (revision 14)
+++ pkipplib/trunk/pkipplib/__init__.py (revision 40)
@@ -1,12 +1,12 @@
 # -*- coding: ISO-8859-15 -*-
 #
-# pkipplib : IPP support for Python
+# pkipplib : IPP and CUPS support for Python
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
-# This program is free software; you can redistribute it and/or modify
+# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
+# the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
-#
+# 
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -15,6 +15,5 @@
 # 
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # $Id$
Index: pkipplib/trunk/pkipplib/version.py
===================================================================
--- pkipplib/trunk/pkipplib/version.py (revision 38)
+++ pkipplib/trunk/pkipplib/version.py (revision 40)
@@ -1,12 +1,12 @@
 # -*- coding: ISO-8859-15 -*-
 #
-# pkipplib : IPP support for Python
+# pkipplib : IPP and CUPS support for Python
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
-# This program is free software; you can redistribute it and/or modify
+# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
+# the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
-#
+# 
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -15,11 +15,10 @@
 # 
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # $Id$
 #
 
-__version__ = "0.08"
+__version__ = "1.00alpha"
 
 __doc__ = "pkipplib : IPP and CUPS support for Python."
@@ -29,7 +28,7 @@
 __years__ = "2003, 2004, 2005, 2006, 2007"
 
-__gplblurb__ = """This program is free software; you can redistribute it and/or modify
+__gplblurb__ = """This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or
+the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
@@ -40,4 +39,3 @@
 
 You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA."""
+along with this program.  If not, see <http://www.gnu.org/licenses/>."""