Index: pykoticon/trunk/setup.py
===================================================================
--- pykoticon/trunk/setup.py (revision 92)
+++ pykoticon/trunk/setup.py (revision 111)
@@ -40,5 +40,5 @@
     withPy2EXE = 1
 
-version = "0.2"
+version = "1.00"
 
 setup(name = "pykoticon", version = version,
Index: pykoticon/trunk/bin/pykoticon
===================================================================
--- pykoticon/trunk/bin/pykoticon (revision 110)
+++ pykoticon/trunk/bin/pykoticon (revision 111)
@@ -56,4 +56,23 @@
     raise ImportError, "wxPython is missing. Please install it."
     
+aboutbox = """PyKotIcon v1.00 (c) 2003, 2004, 2005, 2006 Jerome Alet - alet@librelogiciel.com    
+
+PyKotIcon is a client side print quota notifier for PyKota, but it 
+can be used from other applications if you want.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA."""
+
 def getCurrentUserName() :
     """Retrieves the current user's name."""
@@ -190,9 +209,6 @@
         wx.Frame.__init__(self, parent, id, \
                _("PyKotIcon info for %s") % getCurrentUserName(), \
-               size = (-1, -1), \
-               style = wx.DEFAULT_FRAME_STYLE \
-                     | wx.SIZE_AUTO_HEIGHT \
-                     | wx.SIZE_AUTO_WIDTH \
-                     | wx.NO_FULL_REPAINT_ON_RESIZE)
+               size = (1, 1), \
+               style = wx.FRAME_NO_TASKBAR | wx.NO_FULL_REPAINT_ON_RESIZE)
         try :             
             self.tbicon = wx.TaskBarIcon()
@@ -211,6 +227,9 @@
             wx.EVT_TASKBAR_RIGHT_UP(self.tbicon, self.OnTaskBarMenu)
         
+            self.TBMENU_ABOUT = wx.NewId()
             self.TBMENU_RESTORE = wx.NewId()
             self.TBMENU_CLOSE = wx.NewId()
+            wx.EVT_MENU(self.tbicon, self.TBMENU_ABOUT, \
+                                              self.OnAbout)
             wx.EVT_MENU(self.tbicon, self.TBMENU_RESTORE, \
                                               self.OnTaskBarActivate)
@@ -222,5 +241,5 @@
                 pass
             else :    
-                self.menu.Append(self.TBMENU_RESTORE, _("About"))
+                self.menu.Append(self.TBMENU_ABOUT, _("About"))
                 self.menu.Append(self.TBMENU_CLOSE, _("Quit"))
         
@@ -232,5 +251,5 @@
         if not self.IsIconized() :
             self.Iconize(True)
-        #self.Hide()
+        self.Hide()
 
     def OnTaskBarActivate(self, event) :
@@ -262,4 +281,10 @@
     def OnTaskBarClose(self, event) :
         self.Close()
+        
+    def OnAbout(self, event) :    
+        """Displays the about box."""
+        dialog = wx.MessageDialog(self, aboutbox, _("About"), wx.OK | wx.ICON_INFORMATION)
+        dialog.ShowModal()
+        dialog.Destroy()
         
     def showDialog(self, message, yesno) :
@@ -315,7 +340,9 @@
     
 
-class PyKotIconApp(wx.PySimpleApp):
+class PyKotIconApp(wx.App):
     def OnInit(self) :
         self.frame = PyKotIcon(None, wx.ID_ANY)
+        self.frame.Center(wx.BOTH)
+        self.frame.Show(False)
         return True
         
@@ -323,5 +350,4 @@
         """Continues processing."""
         self.frame.postInit(printserver, localport)
-        #self.frame.Show(True)
         
 def main(printserver, localport):
Index: pykoticon/trunk/NEWS
===================================================================
--- pykoticon/trunk/NEWS (revision 89)
+++ pykoticon/trunk/NEWS (revision 111)
@@ -22,2 +22,5 @@
 PyKotIcon NEWS :
 
+  - 1.00 (2006-03-23) : 
+  
+    - First release